module gw_gao(
    I_TX_EN,
    \I_WADDR[2] ,
    \I_WADDR[1] ,
    \I_WADDR[0] ,
    \I_WDATA[7] ,
    \I_WDATA[6] ,
    \I_WDATA[5] ,
    \I_WDATA[4] ,
    \I_WDATA[3] ,
    \I_WDATA[2] ,
    \I_WDATA[1] ,
    \I_WDATA[0] ,
    I_RX_EN,
    \I_RADDR[2] ,
    \I_RADDR[1] ,
    \I_RADDR[0] ,
    \O_RDATA[7] ,
    \O_RDATA[6] ,
    \O_RDATA[5] ,
    \O_RDATA[4] ,
    \O_RDATA[3] ,
    \O_RDATA[2] ,
    \O_RDATA[1] ,
    \O_RDATA[0] ,
    \u_master_sram_iic/cstate_flag ,
    \u_master_sram_iic/error_flag ,
    clk_sys,
    tms_pad_i,
    tck_pad_i,
    tdi_pad_i,
    tdo_pad_o
);

input I_TX_EN;
input \I_WADDR[2] ;
input \I_WADDR[1] ;
input \I_WADDR[0] ;
input \I_WDATA[7] ;
input \I_WDATA[6] ;
input \I_WDATA[5] ;
input \I_WDATA[4] ;
input \I_WDATA[3] ;
input \I_WDATA[2] ;
input \I_WDATA[1] ;
input \I_WDATA[0] ;
input I_RX_EN;
input \I_RADDR[2] ;
input \I_RADDR[1] ;
input \I_RADDR[0] ;
input \O_RDATA[7] ;
input \O_RDATA[6] ;
input \O_RDATA[5] ;
input \O_RDATA[4] ;
input \O_RDATA[3] ;
input \O_RDATA[2] ;
input \O_RDATA[1] ;
input \O_RDATA[0] ;
input \u_master_sram_iic/cstate_flag ;
input \u_master_sram_iic/error_flag ;
input clk_sys;
input tms_pad_i;
input tck_pad_i;
input tdi_pad_i;
output tdo_pad_o;

wire I_TX_EN;
wire \I_WADDR[2] ;
wire \I_WADDR[1] ;
wire \I_WADDR[0] ;
wire \I_WDATA[7] ;
wire \I_WDATA[6] ;
wire \I_WDATA[5] ;
wire \I_WDATA[4] ;
wire \I_WDATA[3] ;
wire \I_WDATA[2] ;
wire \I_WDATA[1] ;
wire \I_WDATA[0] ;
wire I_RX_EN;
wire \I_RADDR[2] ;
wire \I_RADDR[1] ;
wire \I_RADDR[0] ;
wire \O_RDATA[7] ;
wire \O_RDATA[6] ;
wire \O_RDATA[5] ;
wire \O_RDATA[4] ;
wire \O_RDATA[3] ;
wire \O_RDATA[2] ;
wire \O_RDATA[1] ;
wire \O_RDATA[0] ;
wire \u_master_sram_iic/cstate_flag ;
wire \u_master_sram_iic/error_flag ;
wire clk_sys;
wire tms_pad_i;
wire tck_pad_i;
wire tdi_pad_i;
wire tdo_pad_o;
wire tms_i_c;
wire tck_i_c;
wire tdi_i_c;
wire tdo_o_c;
wire [9:0] control0;
wire gao_jtag_tck;
wire gao_jtag_reset;
wire run_test_idle_er1;
wire run_test_idle_er2;
wire shift_dr_capture_dr;
wire update_dr;
wire pause_dr;
wire enable_er1;
wire enable_er2;
wire gao_jtag_tdi;
wire tdo_er1;

IBUF tms_ibuf (
    .I(tms_pad_i),
    .O(tms_i_c)
);

IBUF tck_ibuf (
    .I(tck_pad_i),
    .O(tck_i_c)
);

IBUF tdi_ibuf (
    .I(tdi_pad_i),
    .O(tdi_i_c)
);

OBUF tdo_obuf (
    .I(tdo_o_c),
    .O(tdo_pad_o)
);

GW_JTAG  u_gw_jtag(
    .tms_pad_i(tms_i_c),
    .tck_pad_i(tck_i_c),
    .tdi_pad_i(tdi_i_c),
    .tdo_pad_o(tdo_o_c),
    .tck_o(gao_jtag_tck),
    .test_logic_reset_o(gao_jtag_reset),
    .run_test_idle_er1_o(run_test_idle_er1),
    .run_test_idle_er2_o(run_test_idle_er2),
    .shift_dr_capture_dr_o(shift_dr_capture_dr),
    .update_dr_o(update_dr),
    .pause_dr_o(pause_dr),
    .enable_er1_o(enable_er1),
    .enable_er2_o(enable_er2),
    .tdi_o(gao_jtag_tdi),
    .tdo_er1_i(tdo_er1),
    .tdo_er2_i(1'b0)
);

gw_con_top  u_icon_top(
    .tck_i(gao_jtag_tck),
    .tdi_i(gao_jtag_tdi),
    .tdo_o(tdo_er1),
    .rst_i(gao_jtag_reset),
    .control0(control0[9:0]),
    .enable_i(enable_er1),
    .shift_dr_capture_dr_i(shift_dr_capture_dr),
    .update_dr_i(update_dr)
);

ao_top_0  u_la0_top(
    .control(control0[9:0]),
    .trig0_i({\u_master_sram_iic/cstate_flag ,\u_master_sram_iic/error_flag }),
    .data_i({I_TX_EN,\I_WADDR[2] ,\I_WADDR[1] ,\I_WADDR[0] ,\I_WDATA[7] ,\I_WDATA[6] ,\I_WDATA[5] ,\I_WDATA[4] ,\I_WDATA[3] ,\I_WDATA[2] ,\I_WDATA[1] ,\I_WDATA[0] ,I_RX_EN,\I_RADDR[2] ,\I_RADDR[1] ,\I_RADDR[0] ,\O_RDATA[7] ,\O_RDATA[6] ,\O_RDATA[5] ,\O_RDATA[4] ,\O_RDATA[3] ,\O_RDATA[2] ,\O_RDATA[1] ,\O_RDATA[0] ,\u_master_sram_iic/cstate_flag ,\u_master_sram_iic/error_flag }),
    .clk_i(clk_sys)
);

endmodule
