## part 1: new lib
vlib work
vmap work work


## part 2: load design
vlog -novopt -incr -work work "../../simlib/gw1n/prim_sim.v"
vlog -novopt -incr -work work "../../project/gw_i2c_master/src/gowin_rpll/gowin_rpll.v"
vlog -novopt -incr -work work "../../project/gw_i2c_master/src/i2c_master/i2c_master.vo"
vlog -novopt -incr -work work "../../project/gw_i2c_master/src/master_sram_iic.v"
vlog -novopt -incr -work work "../../project/gw_i2c_master/src/gw_i2c_master.v"
vlog -novopt -incr -work work "../../project/gw_i2c_slave/impl/pnr/gw_i2c_slave.vo"
vlog -novopt -incr -work work "../../tb/i2c_tb.v"


## part 3: sim design
vsim -novopt work.i2c_tb


## part 4: add signals
##add wave *
add wave -noupdate /i2c_tb/clk
add wave -noupdate /i2c_tb/rst
add wave -noupdate /i2c_tb/key2
add wave -noupdate /i2c_tb/scl
add wave -noupdate /i2c_tb/sda
add wave -noupdate /i2c_tb/error_flag
add wave -noupdate /i2c_tb/u_gw_i2c_master/u_master_sram_iic/cstate_flag
add wave -noupdate /i2c_tb/u_gw_i2c_master/I_TX_EN
add wave -noupdate /i2c_tb/u_gw_i2c_master/I_WADDR
add wave -noupdate /i2c_tb/u_gw_i2c_master/I_WDATA
add wave -noupdate /i2c_tb/u_gw_i2c_master/I_RX_EN
add wave -noupdate /i2c_tb/u_gw_i2c_master/I_RADDR
add wave -noupdate /i2c_tb/u_gw_i2c_master/O_RDATA


## part 5: show ui 
view wave
view structure
view signals


## part 6: run 
run -all

