
`timescale 1ns/1ps

module i2c_tb;

//input
    reg     clk;
    reg     rst;
	reg     key2;

//output
    wire    scl;
    wire    sda;
    wire    error_flag;
    wire    cstate_flag;
//    wire    interupt;

    pullup p1(scl); // pullup scl line
    pullup p2(sda); // pullup sda line

    GSR GSR(.GSRI(1'b1));
    
    gw_i2c_master u_gw_i2c_master  (
        .clk_50m(clk),
        .rst_n(rst),
		.key2(key2),
        .scl(scl),
        .scl_pull(),	
        .sda(sda),
		.sda_pull(),
        .error_flag(error_flag),
        .cstate_flag(cstate_flag),
        .interupt()
    );

    gw_i2c_slave u_gw_i2c_slave (
        .clk_50m(clk),
        .rst_n(rst),
        .scl(scl),
        .scl_pull(),		
        .sda(sda),
		.sda_pull(),		
        .int_o()
    );

    initial begin
        clk=0;
        forever #10 clk=~clk;
    end

    initial begin
        rst=1;
        key2=1;		
        #2000000;
        rst=0;
        #6000000;
        rst=1;
        #2000000;
        key2=0;
        #6000000;
        key2=1;
        #2000000;
        key2=0;
        #6000000;
        key2=1;
        #2000000;
        key2=0;
        #6000000;
        key2=1;
        #2000000;
		
		$stop;		
    end

endmodule
